package de.hft.stuttgart.citydoctor2.healing;

import java.util.Collections;
import java.util.List;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import de.hft.stuttgart.citydoctor2.check.HealingID;
import de.hft.stuttgart.citydoctor2.check.HealingMethod;
import de.hft.stuttgart.citydoctor2.check.ModificationListener;
import de.hft.stuttgart.citydoctor2.check.error.PolygonSameOrientationError;
import de.hft.stuttgart.citydoctor2.datastructure.Vertex;

public class HealSameOrientationError implements HealingMethod {
	
	private static final Logger logger = LogManager.getLogger(HealSameOrientationError.class);

	@Override
	public boolean visit(PolygonSameOrientationError err, ModificationListener l) {
		logger.debug("Executing Repair for PolygonSameOrientationError");
		List<Vertex> vertices = err.getInnerRing().getVertices();
		Collections.reverse(vertices);
		return true;
	}

	@Override
	public HealSameOrientationError createNew() {
		return new HealSameOrientationError();
	}

	@Override
	public HealingID getID() {
		return HealingID.P_SAME_ORIENTATION;
	}

}
